<?php
if (!defined('DC_RC_PATH')) { return; }

$core->tpl->addValue('EntryShortURL',array('tplShortURL','EntryShortURL'));

class tplShortURL
{
	public static function EntryShortURL($attr)
	{
		$f = $GLOBALS['core']->tpl->getFilters($attr);
		if ($GLOBALS['core']->blog->settings->shortURLEnabled) {
			return '<?php echo '.sprintf($f,'$core->blog->url.$core->url->getBase("shortURL").'.
				'"/".rawurlencode($_ctx->posts->post_id)').'; ?>';
		}
		return '';
	}
}

class shortURL extends dcUrlHandlers
{
	public static function postById($args)
	{
		$params = array();
		$params['no_content'] = 1;
		$params['post_id'] = $args;
		$params['post_type'] = '';

		// Try to find the post
		$result = $GLOBALS['core']->blog->getPosts($params);
		if (!$result) {
			self::p404();
		}

		// Try to find the URL to go with it
		$base = $GLOBALS['core']->url->getBase($result->post_type);
		if (!$base) {
			// try an alternate via the plural of the post_type. Should work for pages.
			$base = $GLOBALS['core']->url->getBase($result->post_type.'s');
		}
		if (!$base) {
			self::p404();
		}

		$url = $GLOBALS['core']->blog->url.$base.'/'.$result->post_url;
		http::head(302, 'Found');
		header('Location: '.$url);
		exit;
	}
	
}
?>
